// Robot Motor Control for ESP32-CAM Robot
// Tx Out from ESP32 to Rx0 on Nano
// need common Ground
// 2019 - Gord Payne

int curDir = -1; //current direction
int mAe = 4; // motor A enable
int mAp = 5; // motor A speed PWM
int mBe = 2; // motor B enable
int mBp = 3; // motor B PWM
char theDir = ' ';
void setup() {

  Serial.begin(115200); // esp32 communications speed
  
  pinMode(mAe, OUTPUT);
  pinMode(mAp, OUTPUT);
  pinMode(mBe, OUTPUT);
  pinMode(mBp, OUTPUT);
  digitalWrite(mAe, LOW);
  analogWrite(mAp, 0);
  digitalWrite(mBe, LOW);
  analogWrite(mBp, 0);

}

void loop() {
  if (Serial.available() > 0) { // if a keystroke received from ESP32
    curDir = Serial.read();// read the byte
   
    switch (curDir) {
      
      case 48://0 unassigned
        break;
      case 49://1 Reverse Left
        digitalWrite(mAe, HIGH);
        analogWrite(mAp, 190);
        digitalWrite(mBe, HIGH);
        analogWrite(mBp, 135);
        break;
      case 50://2 Reverse
        digitalWrite(mAe, HIGH);
        analogWrite(mAp, 170);
        digitalWrite(mBe, HIGH);
        analogWrite(mBp, 180);
        break;
      case 51://3 Reverse Right
        digitalWrite(mAe, HIGH);
        analogWrite(mAp, 135);
        digitalWrite(mBe, HIGH);
        analogWrite(mBp, 190);
        break;
      case 52://4 Rotate Left
        digitalWrite(mAe, HIGH);
        analogWrite(mAp, 200);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 55);
        break;
      case 53://5 STOP
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 0);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 0);
        break;
      case 54://6 Rotate Right
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 55);
        digitalWrite(mBe, HIGH);
        analogWrite(mBp, 200);
        break;
      case 55://7 Forward Left
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 65);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 120);
        break;
      case 56://8 Forward
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 130);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 130);
        break;
      case 57://9 Forward Right
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 120);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 65);
        break;
      default: // STOP
        digitalWrite(mAe, LOW);
        analogWrite(mAp, 0);
        digitalWrite(mBe, LOW);
        analogWrite(mBp, 0);
        break;
    }
  }
}
